searchNodes=[{"doc":"A library for CAN in Elixir.","ref":"Cannes.html","title":"Cannes","type":"module"},{"doc":"This module is the counterpart to the Cannes.Dumper. With the help of the included functions it is possible to send CAN messages","ref":"Cannes.Compostor.html","title":"Cannes.Compostor","type":"module"},{"doc":"","ref":"Cannes.Compostor.html#send/3","title":"Cannes.Compostor.send/3","type":"function"},{"doc":"This module is for communicating with linux can sockets over candump. TODO:Add logic to mount a can interfaceTest if desired interface is reacableTest if candump is availablePass options to candump","ref":"Cannes.Dumper.html","title":"Cannes.Dumper","type":"module"},{"doc":"Check if the candump process is still running.","ref":"Cannes.Dumper.html#alive?/1","title":"Cannes.Dumper.alive?/1","type":"function"},{"doc":"Parses the given candump string in the candump log format into a map.Exampleiex&gt; Cannes.Dumper.format_candump_string(&quot;(1398128227.045337) can0 133#0000000098&quot;) %{ data: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 9&gt;&gt;, identifier: &lt;&lt;1, 51&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1398128227.045337 }","ref":"Cannes.Dumper.html#format_candump_string/2","title":"Cannes.Dumper.format_candump_string/2","type":"function"},{"doc":"Returns a stream of formatted can messages.Example iex&gt; Cannes.Dumper.get_formatted_stream(proc) #Stream&lt;[ enum: #Function&lt;63.104660160/2 in Stream.unfold/2&gt;, funs: [#Function&lt;51.104660160/1 in Stream.reject/2&gt;, #Function&lt;38.104660160/1 in Stream.map/2&gt;] ]&gt;","ref":"Cannes.Dumper.html#get_formatted_stream/1","title":"Cannes.Dumper.get_formatted_stream/1","type":"function"},{"doc":"","ref":"Cannes.Dumper.html#get_stream/1","title":"Cannes.Dumper.get_stream/1","type":"function"},{"doc":"Spawns a candump process on the given interface.Exampleiex&gt; Cannes.Dumper.start(&quot;vcan0&quot;) %Porcelain.Process{ err: nil, out: #Function&lt;63.104660160/2 in Stream.unfold/2&gt;, pid: #PID&lt;0.212.0&gt; }","ref":"Cannes.Dumper.html#start/1","title":"Cannes.Dumper.start/1","type":"function"},{"doc":"Stops a running candump process carefully.Exampleproc = Cannes.Dumper.stop(proc) true","ref":"Cannes.Dumper.html#stop/1","title":"Cannes.Dumper.stop/1","type":"function"},{"doc":"Provides some usefull functions for simulating can messages. TODO:More advanced mocking for can messages","ref":"Cannes.Mock.html","title":"Cannes.Mock","type":"module"},{"doc":"Returns an infinite stream of formatted can messages. Currently we use a simple logging file as blueprints for the messagesExamplesiex&gt; stream = Cannes.Mock.file_stream() #Function&lt;63.104660160/2 in Stream.unfold/2&gt; iex&gt; Enum.take(stream, 5) [ %{ data: &lt;&lt;0, 0, 0, 0, 0, 208, 50, 0&gt;&gt;, identifier: &lt;&lt;1, 102&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1398128223.803317 }, %{ data: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, identifier: &lt;&lt;1, 88&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1398128223.804583 }, %{ data: &lt;&lt;0, 0, 0, 5, 80, 1, 8, 0&gt;&gt;, identifier: &lt;&lt;1, 97&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1398128223.804828 }, %{ data: &lt;&lt;0, 0, 1, 0, 144, 161, 65, 0&gt;&gt;, identifier: &lt;&lt;1, 145&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1398128223.805039 }, %{ data: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 0&gt;&gt;, identifier: &lt;&lt;1, 142&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1398128223.80535 } ] iex&gt; Cannes.Mock.file_stream(true) |&gt; Enum.take(2) [ %{ data: &lt;&lt;0, 0, 0, 0, 208, 50, 0, 9&gt;&gt;, identifier: &lt;&lt;1, 102&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1611064041 }, %{ data: &lt;&lt;0, 0, 0, 0, 0, 0, 0, 10&gt;&gt;, identifier: &lt;&lt;1, 88&gt;&gt;, interface: &quot;can0&quot;, timestamp: 1611064041 } ]","ref":"Cannes.Mock.html#file_stream/1","title":"Cannes.Mock.file_stream/1","type":"function"},{"doc":"Cannes.Tools facilitates a usefull wrapper for the python library called cantool.","ref":"Cannes.Tools.html","title":"Cannes.Tools","type":"module"},{"doc":"Decode given signal data data as a message of given frame id or name frame_id_or_name. Returns a dictionary of signal name-value entries.If decode_choices is false scaled values are not converted to choice strings (if available).If scaling is false no scaling of signals is performed.Exampleiex&gt; Cannes.Tools.decode_message(2024, &lt;&lt;0x04, 0x41, 0x0C, 0x02, 0x6A, 0x00, 0x00, 0x00&gt;&gt;) %{ 'ParameterID_Service01' =&gt; 'S1_PID_0C_EngineRPM', 'S1_PID_0C_EngineRPM' =&gt; 154.5, 'length' =&gt; 4, 'response' =&gt; 4, 'service' =&gt; 'Show current data ' }","ref":"Cannes.Tools.html#decode_message/4","title":"Cannes.Tools.decode_message/4","type":"function"},{"doc":"Encode given signal data data as a message of given frame id or name frame_id_or_name. data is a dictionary of signal name-value entries.If scaling is false no scaling of signals is performed.If padding is true unused bits are encoded as 1.If strict is true all signal values must be within their allowed ranges, or an exception is raised.Exampleiex&gt; Cannes.Tools.encode_message(2024, %{&quot;ParameterID_Service01&quot; =&gt; &quot;S1_PID_0C_EngineRPM&quot;, &quot;S1_PID_0C_EngineRPM&quot; =&gt; 154.5, &quot;length&quot; =&gt; 4, &quot;response&quot; =&gt; 4, &quot;service&quot; =&gt; &quot;Show current data &quot;}) &lt;&lt;4, 65, 12, 2, 106, 0, 0, 0&gt;&gt;","ref":"Cannes.Tools.html#encode_message/5","title":"Cannes.Tools.encode_message/5","type":"function"},{"doc":"Calls the given function with args from the given Python file.","ref":"Cannes.Tools.html#python_call/3","title":"Cannes.Tools.python_call/3","type":"function"},{"doc":"&lt;img src=&quot;logo.png&quot; width=&quot;350px&quot;&gt; A library for CAN written in Elixir.Documentation: https://hexdocs.pm/cannesINFO:Cannes is still under development and by far not complete. Feel free to contribute.See General Informations for more about this project","ref":"readme.html","title":"README","type":"extras"},{"doc":"To use Cannes in your Mix projects, first add Cannes as a dependency.def deps do [ {:cannes, &quot;~&gt; 0.0.5&quot;} ] end","ref":"readme.html#installation","title":"README - Installation","type":"extras"},{"doc":"Install Python v3.xInstall Elixir v1.11+Setup a virtualenv and activate itRun pip install -r requirements.txt to install the python dependenciesRun mix deps.get to install the Hex dependencies","ref":"readme.html#prerequisites","title":"README - Prerequisites","type":"extras"},{"doc":"This is a small part of my master thesis. In the meantime, if anyone would like to add anything, feel free to do so.","ref":"readme.html#general-informations","title":"README - General Informations","type":"extras"},{"doc":"See the changelog for changes between versions.","ref":"readme.html#release-notes","title":"README - Release notes","type":"extras"},{"doc":"Changelogv0.0.4, 19 Jan 2021, Elixir ~&gt; 1.11Added ability to get real unix timestamp in can messageStarted with basic implementation of CompostorModulev0.0.3, 28 Dec 2020, Elixir ~&gt; 1.11Fixed issue with multiple CAN messages in one stream elementv0.0.2, 27 Dec 2020, Elixir ~&gt; 1.11Added Dumper Module to communicate with linux can socketsAdded Mock Module for simulating can messagesAdded Tools Module to rewrap existing functions that were previously in the Cannes Modulev0.0.1, 25 Dec 2020, Elixir ~&gt; 1.11Alpha Version release for Cannes.","ref":"changelog.html","title":"Changelog","type":"extras"}]